diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 377bbd9a6..4caa237e7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -1,18 +1,20 @@
 package net.minecraft.client.render.item.model;
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.collection.NamespaceID;
-import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 
 import java.awt.*;
@@ -21,14 +23,6 @@ import java.util.Map;
 import java.util.Objects;
 import java.util.Random;
 
-import static org.lwjgl.opengl.GL11.GL_BLEND;
-import static org.lwjgl.opengl.GL11.GL_DEPTH_TEST;
-import static org.lwjgl.opengl.GL11.GL_LIGHTING;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
-import static org.lwjgl.opengl.GL11.glBlendFunc;
-import static org.lwjgl.opengl.GL11.glDisable;
-import static org.lwjgl.opengl.GL11.glEnable;
-
 public class ItemModelStandard extends ItemModel{
     protected static final Random random = new Random();
 
@@ -62,28 +56,23 @@ public class ItemModelStandard extends ItemModel{
     }
 
     @Override
-    public void render(@NotNull final Tessellator tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, final float brightness, final float alpha, final float partialTick, final boolean mirrorX) {
+    public void render(@NotNull final TessellatorGeneral tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, int lightmapCoord, final float partialTick, final boolean mirrorX) {
         random.setSeed(187L);
         final DisplayPos displayPos = getDisplayPos(displayPosId);
 
-        GL11.glTranslatef(displayPos.tx, displayPos.ty, displayPos.tz);
-        GL11.glRotatef(displayPos.rx, 1, 0, 0);
-        GL11.glRotatef(displayPos.ry, 0, 1, 0);
-        GL11.glRotatef(displayPos.rz, 0, 0, 1);
-        GL11.glScalef(displayPos.sx, displayPos.sy, displayPos.sz);
-        final int color = getColor(itemStack);
-        final float r = net.minecraft.core.util.helper.Color.redFromInt(color)/255f;
-        final float g = net.minecraft.core.util.helper.Color.greenFromInt(color)/255f;
-        final float b = net.minecraft.core.util.helper.Color.blueFromInt(color)/255f;
-        GL11.glColor4f(brightness * r, brightness * g, brightness * b, alpha);
+        GLRenderer.modelM4f().translate(displayPos.tx, displayPos.ty, displayPos.tz);
+        GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(displayPos.rx));
+        GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(displayPos.ry));
+        GLRenderer.modelM4f().rotateZ(org.joml.Math.toRadians(displayPos.rz));
+        GLRenderer.modelM4f().scale(displayPos.sx, displayPos.sy, displayPos.sz);
         if (items3d) {
             for (int i = 0; i < clusterSize; i++) {
                 final float offX = 0;
                 final float offY = 0;
                 final float offZ = 0.1f * i;
-                GL11.glTranslatef(offX, offY, offZ);
-                renderSingle(tessellator, holder, itemStack, true, brightness, alpha, partialTick, mirrorX);
-                GL11.glTranslatef(-offX, -offY, -offZ);
+                GLRenderer.modelM4f().translate(offX, offY, offZ);
+                renderSingle(tessellator, holder, itemStack, true, lightmapCoord, getColor(itemStack), partialTick, mirrorX);
+                GLRenderer.modelM4f().translate(-offX, -offY, -offZ);
             }
         } else {
             for (int i = 0; i < clusterSize; i++) {
@@ -95,18 +84,18 @@ public class ItemModelStandard extends ItemModel{
                     rOffY = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sy;
                     rOffZ = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sz;
                 }
-                GL11.glTranslatef(rOffX, rOffY, rOffZ);
-                renderSingle(tessellator, holder, itemStack, false, brightness, alpha, partialTick, mirrorX);
-                GL11.glTranslatef(-rOffX, -rOffY, -rOffZ);
+                GLRenderer.modelM4f().translate(rOffX, rOffY, rOffZ);
+                renderSingle(tessellator, holder, itemStack, false, lightmapCoord, getColor(itemStack), partialTick, mirrorX);
+                GLRenderer.modelM4f().translate(-rOffX, -rOffY, -rOffZ);
             }
         }
     }
 
-    protected void renderSingle(@NotNull final Tessellator tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, final boolean items3d, final float brightness, final float alpha, final float partialTick, final boolean mirrorX) {
-        renderCoordinate(tessellator, getIcon(holder, itemStack), items3d, mirrorX);
+    protected void renderSingle(@NotNull final TessellatorGeneral tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, final boolean items3d, int lightmapCoord, int color, final float partialTick, final boolean mirrorX) {
+        renderCoordinate(tessellator, getIcon(holder, itemStack), this.itemfullBright ? LightmapHelper.getLightmapCoord(15, 15) : lightmapCoord, color, items3d, mirrorX);
     }
 
-    protected void renderCoordinate(@NotNull final Tessellator tessellator, @NotNull final IconCoordinate coordinate, final boolean items3d, final boolean mirrorX) {
+    protected void renderCoordinate(@NotNull final TessellatorGeneral tessellator, @NotNull final IconCoordinate coordinate, int lightmap, int color, final boolean items3d, final boolean mirrorX) {
         final double cUMin = mirrorX ? coordinate.getIconUMax() : coordinate.getIconUMin();
         final double cUMax = mirrorX ? coordinate.getIconUMin() : coordinate.getIconUMax();
         final double cVMin = coordinate.getIconVMin();
@@ -119,6 +108,8 @@ public class ItemModelStandard extends ItemModel{
             final int pxW = coordinate.width;
 
             tessellator.startDrawingQuads();
+            tessellator.setLightmapCoord1i(lightmap);
+            tessellator.setColor1i(color);
             // front
             tessellator.setNormal(0, 0, -1);
             tessellator.addVertexWithUV(-0.5,  0.5, -halfThickness, cUMin, cVMin);
@@ -181,6 +172,8 @@ public class ItemModelStandard extends ItemModel{
             tessellator.draw();
         } else {
             tessellator.startDrawingQuads();
+            tessellator.setLightmapCoord1i(lightmap);
+            tessellator.setColor1i(color);
             tessellator.setNormal(0, 1, 0);
             tessellator.addVertexWithUV(-0.5,  0.5, 0, cUMin, cVMin);
             tessellator.addVertexWithUV(-0.5, -0.5, 0, cUMin, cVMax);
@@ -206,46 +199,46 @@ public class ItemModelStandard extends ItemModel{
     }
 
     @Override
-    public void renderItemOverlayIntoGUI(@NotNull final Tessellator tessellator, @NotNull final FontRenderer fontRenderer, @NotNull final TextureManager textureManager, @NotNull final ItemStack itemstack, final int x, final int y, @Nullable final String override, final float alpha) {
-        glEnable(GL_BLEND);
-        glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+    public void renderItemOverlayIntoGUI(@NotNull final TessellatorGeneral tessellator, @NotNull final FontRenderer fontRenderer, @NotNull final TextureManager textureManager, @NotNull final ItemStack itemstack, final int x, final int y, @Nullable final String override, final float alpha) {
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         final int a = (int) (alpha * 255.0f);
         if (itemstack.stackSize != 1 || override != null) {
             final String s = override != null ? override : "" + itemstack.stackSize;
-            GL11.glDisable(GL_LIGHTING);
-            GL11.glDisable(GL_DEPTH_TEST);
-            fontRenderer.render(tessellator, s, (x + 19) - 2 - fontRenderer.stringWidth(s), y + 6 + 3).setShadow().setColor(0xffffff | (a << 24)).call();
-            GL11.glEnable(GL_LIGHTING);
-            GL11.glEnable(GL_DEPTH_TEST);
+//            GL11.glDisable(GL_LIGHTING);
+            GLRenderer.disableState(State.DEPTH_TEST);
+            fontRenderer.render(s, (x + 19) - 2 - fontRenderer.stringWidth(s), y + 6 + 3).setShadow().setColor(0xffffff | (a << 24)).call();
+//            GL11.glEnable(GL_LIGHTING);
+            GLRenderer.enableState(State.DEPTH_TEST);
         }
         if (itemstack.isItemDamaged() || itemstack.getItem().showFullDurability()) {
             final int barWidth = (int) Math.round(13D - (itemstack.getItemDamageForDisplay() * 13D) / itemstack.getMaxDamage());
             final int progress = (int) Math.round(255D - (itemstack.getItemDamageForDisplay() * 255D) / itemstack.getMaxDamage());
-            GL11.glDisable(GL_LIGHTING);
-            GL11.glDisable(GL_DEPTH_TEST);
-            GL11.glDisable(GL_TEXTURE_2D);
+//            GL11.glDisable(GL_LIGHTING);
+            GLRenderer.pushFrame();
+            GLRenderer.disableState(State.DEPTH_TEST);
+            GLRenderer.setShader(Shaders.COLOR);
             final int colorFG = Color.HSBtoRGB(progress / 255F / 3F, 1f, 1f);
             final int colorBG = (0xFF - progress) / 4 << 16 | 0x3f00;
+            tessellator.startDrawingQuads();
             renderColoredQuad(tessellator, x + 2, y + 13, 13, 2, 0, a);
             renderColoredQuad(tessellator, x + 2, y + 13, 12, 1, colorBG, a);
             renderColoredQuad(tessellator, x + 2, y + 13, barWidth, 1, colorFG, a);
-            GL11.glEnable(GL_TEXTURE_2D);
-            GL11.glEnable(GL_LIGHTING);
-            GL11.glEnable(GL_DEPTH_TEST);
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            tessellator.draw();
+            GLRenderer.popFrame();
+//            GL11.glEnable(GL_LIGHTING);
         }
-        glDisable(GL_BLEND);
+        GLRenderer.popFrame();
     }
 
-    protected void renderColoredQuad(final Tessellator tessellator, final int x, final int y, final int width, final int height, final int colorRGB, final int alpha) {
+    protected void renderColoredQuad(final TessellatorGeneral tessellator, final int x, final int y, final int width, final int height, final int colorRGB, final int alpha) {
         final float z = 0.0F;
-        tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_I(colorRGB, alpha);
+        tessellator.setColor2i(colorRGB, alpha);
         tessellator.addVertex(x,        y,          z);
         tessellator.addVertex(x,        y + height, z);
         tessellator.addVertex(x + width,y + height, z);
         tessellator.addVertex(x + width,y,          z);
-        tessellator.draw();
     }
 
     public @NotNull IconCoordinate getIcon(@Nullable final Entity entity, final ItemStack itemStack){
@@ -257,7 +250,7 @@ public class ItemModelStandard extends ItemModel{
     }
     public int getColorFromMeta(final int meta)
     {
-        return 0xffffff;
+        return 0xffffffff;
     }
 
     public ItemModelStandard setFullBright()
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
index f8fb8869f..b7e7fb6a4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
@@ -1,10 +1,9 @@
 package net.minecraft.client.render.particle;
 
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.ParticleEngine;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
@@ -74,9 +73,6 @@ public class Particle {
         this.x = x;
         this.y = y;
         this.z = z;
-        this.xo = this.x;
-        this.yo = this.y;
-        this.zo = this.z;
         this.rCol = this.gCol = this.bCol = 1.0F;
         this.xd = xa + (float) (Math.random() * 2D - 1.0D) * 0.4F;
         this.yd = ya + (float) (Math.random() * 2D - 1.0D) * 0.4F;
@@ -91,10 +87,13 @@ public class Particle {
         this.size = (random.nextFloat() * 0.5F + 0.5F) * 2.0F;
         this.lifetime = (int) (4F / (random.nextFloat() * 0.9F + 0.1F));
         this.age = 0;
+    }
 
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+    public void init() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        this.cachedLightmapCoord = calcLightmap(1f);
     }
 
     /**
@@ -120,9 +119,7 @@ public class Particle {
     }
 
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -272,15 +269,10 @@ public class Particle {
      * @param t           The tessellator to use to draw the particle.
      * @param partialTick The time since the last tick.
      */
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
-        float br = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            t.setLightmapCoord(getLightmap(partialTick));
-        } else if (!Global.accessor.isFullbrightEnabled()) {
-            br = getBrightness(partialTick);
-        }
-        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
@@ -290,12 +282,12 @@ public class Particle {
             this.tex.getIconUSize(), this.tex.getIconVSize());
     }
 
-    public void renderLit(@NotNull Tessellator t, float partialTick, double xOff, double yOff, double zOff) {
+    public void renderLit(@NotNull TessellatorGeneral t, float partialTick, double xOff, double yOff, double zOff) {
 
     }
 
     public int getParticleTexture() {
-        return ParticleEngine.PARTICLE_TEXTURE;
+        return ParticleEngine.WORLD_TEXTURE;
     }
 
     public float calcBrightness(float partialTick) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
index ac0a91431..014541f3c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -32,7 +31,7 @@ public class ParticleArrowGolden extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -46,9 +45,7 @@ public class ParticleArrowGolden extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
index f91133675..20397c62e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 
@@ -17,9 +16,7 @@ public class ParticleAsh extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
index 889106529..b919a180e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -17,6 +17,7 @@ import org.jetbrains.annotations.NotNull;
 public class ParticleBlockBreaking extends Particle {
     private final Block<?> block;
     private final Side side;
+    private TilePos initPos = new TilePos(Integer.MAX_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
 
     public ParticleBlockBreaking(World world, double x, double y, double z, double xa, double ya, double za, Block<?> block, Side side, int meta) {
         super(world, x, y, z, xa, ya, za);
@@ -29,6 +30,7 @@ public class ParticleBlockBreaking extends Particle {
     }
 
     public ParticleBlockBreaking init(@NotNull TilePos tilePos) {
+        this.initPos = tilePos;
         int meta = this.world.getBlockData(tilePos);
         BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(this.block);
         int index = model.particleColorIndex(this.world, tilePos, this.side, meta);
@@ -42,24 +44,73 @@ public class ParticleBlockBreaking extends Particle {
     }
 
     @Override
-    public int getParticleTexture() {
-        return ParticleEngine.TERRAIN_TEXTURE;
-    }
-
-    @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
-        float br = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            t.setLightmapCoord(getLightmap(partialTick));
-        } else if (!Global.accessor.isFullbrightEnabled()) {
-            br = getBrightness(partialTick);
-        }
-        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick), this.size * 0.1f,
             this.tex.getIconUMin() + (this.tex.getIconUSize() * this.uo / 4F), this.tex.getIconVMin() + (this.tex.getIconVSize() * this.uo / 4F), this.tex.getIconUSize() * 0.25f, this.tex.getIconVSize() * 0.25f);
     }
+
+    @Override
+    public int calcLightmap(float partialTick) {
+        if (Global.accessor.isFullbrightEnabled()) return 15 << 20 | 15;
+        TilePos blockPos = new TilePos(
+            MathHelper.lerp(this.xo, this.x, partialTick),
+            MathHelper.lerp(this.yo, this.y, partialTick),
+            MathHelper.lerp(this.zo, this.z, partialTick));
+
+        final int skylight;
+        final int blocklight;
+        if (this.world.getBlockLitInteriorSurface(blockPos) || blockPos.equals(this.initPos)) {
+            TilePos queryPos = new TilePos();
+
+            int bU = this.world.getSavedLightValue(LightLayer.Block, blockPos.up(queryPos));
+            final int bW = this.world.getSavedLightValue(LightLayer.Block, blockPos.west(queryPos));
+            final int bE = this.world.getSavedLightValue(LightLayer.Block, blockPos.east(queryPos));
+            final int bS = this.world.getSavedLightValue(LightLayer.Block, blockPos.south(queryPos));
+            final int bN = this.world.getSavedLightValue(LightLayer.Block, blockPos.north(queryPos));
+            if (bW > bU) {
+                bU = bW;
+            }
+            if (bE > bU) {
+                bU = bE;
+            }
+            if (bS > bU) {
+                bU = bS;
+            }
+            if (bN > bU) {
+                bU = bN;
+            }
+            blocklight = bU;
+
+            int sU = this.world.getSavedLightValue(LightLayer.Sky, blockPos.up(queryPos));
+            final int sW = this.world.getSavedLightValue(LightLayer.Sky, blockPos.west(queryPos));
+            final int sE = this.world.getSavedLightValue(LightLayer.Sky, blockPos.east(queryPos));
+            final int sS = this.world.getSavedLightValue(LightLayer.Sky, blockPos.south(queryPos));
+            final int sN = this.world.getSavedLightValue(LightLayer.Sky, blockPos.north(queryPos));
+            if (sW > sU) {
+                sU = sW;
+            }
+            if (sE > sU) {
+                sU = sE;
+            }
+            if (sS > sU) {
+                sU = sS;
+            }
+            if (sN > sU) {
+                sU = sN;
+            }
+            skylight = sU;
+
+        } else {
+            skylight = this.world.getSavedLightValue(LightLayer.Sky, blockPos);
+            blocklight = this.world.getSavedLightValue(LightLayer.Block, blockPos);
+        }
+
+        return this.world.getLightmapCoord(skylight, blocklight);
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
index 705badb1e..fc9bb4af9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
@@ -25,9 +24,7 @@ public class ParticleBubble extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java
index 4adb6a68e..27ca2a5bc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 
@@ -17,9 +16,7 @@ public class ParticleExplode extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
index 694fcc066..4cab8c024 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -82,7 +82,7 @@ public class ParticleFirefly extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float ibr = getInternalBrightness(partialTick);
         if (ibr < 0.5f) {
             this.rCol = MathHelper.lerp(this.minR, this.midR, ibr * 2);
@@ -101,7 +101,7 @@ public class ParticleFirefly extends Particle {
         super.render(t, partialTick);
     }
 
-    public void renderParticleInGui(Tessellator t, float partialTick) {
+    public void renderParticleInGui(TessellatorGeneral t, float partialTick) {
         float ibr = getInternalBrightness(partialTick);
         if (ibr < 0.5f) {
             this.rCol = MathHelper.lerp(this.minR, this.midR, ibr * 2);
@@ -125,13 +125,8 @@ public class ParticleFirefly extends Particle {
         float x = (float) (this.xo + (this.x - this.xo) * partialTick);
         float y = (float) (this.yo + (this.y - this.yo) * partialTick);
         float z = (float) (this.zo + (this.z - this.zo) * partialTick);
-        float br = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            t.setLightmapCoord(getLightmap(partialTick));
-        } else {
-            br = getBrightness(partialTick);
-        }
-        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addVertexWithUV(x + r, y - r, z / 10, u2, v2);
         t.addVertexWithUV(x + r, y + r, z / 10, u2, v0);
         t.addVertexWithUV(x - r, y + r, z / 10, u0, v0);
@@ -169,9 +164,7 @@ public class ParticleFirefly extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.sinTimer++;
         if (this.sinTimer > 100) {
             this.sinTimer = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java
index 2030b65b8..19b708ded 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
@@ -27,7 +27,7 @@ public class ParticleFlame extends Particle {
     }
 
     @Override
-    public void render(@NotNull ParticleTessellator t, float partialTick) {
+    public void render(@NotNull TessellatorParticle t, float partialTick) {
         float s = ((float) this.age + partialTick) / (float) this.lifetime;
         this.size = this.oSize * (1.0F - s * s * 0.5F);
         super.render(t, partialTick);
@@ -46,9 +46,7 @@ public class ParticleFlame extends Particle {
 
     @Override
     public void tick() {
-        if (LightmapHelper.isLightmapEnabled()) {
-            this.cachedLightmapCoord = calcLightmap(1f);
-        }
+        this.cachedLightmapCoord = calcLightmap(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
